function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { extractImports } from "@mintsourcejs/mdxjs-common";
import classnames from "classnames";
import { themes } from "prism-react-renderer";
import PropTypes from "prop-types";
import React, { useMemo, useState } from "react";
import { LiveEditor, LiveError, LivePreview, LiveProvider } from "react-live";
import { EmbedIcon } from "./icons/EmbedIcon.js";
import { useMdxScope } from "./useMdxScope.js";
import styles from "./CodeLive.module.css";
export var CodeLive = function CodeLive(_ref) {
  var className = _ref.className,
    code = _ref.code,
    language = _ref.language,
    live = _ref.live,
    noInline = _ref.noInline,
    scopeMapping = _ref.scopeMapping,
    theme = _ref.theme;
  var scope = useMdxScope(scopeMapping);
  var imports = useMemo(function () {
    return extractImports(code);
  }, [code]);

  // if there are any imports, strip them out of the code block.
  var raw = imports.length > 0 ? code.replace(/import\s+[\s\S]*?["'][^"']+["'];?/g, '').trim() : code;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  return /*#__PURE__*/React.createElement(LiveProvider, {
    code: raw,
    scope: scope,
    theme: theme,
    noInline: noInline
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.codeLive
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.codeExample
  }, /*#__PURE__*/React.createElement(LivePreview, null), /*#__PURE__*/React.createElement(LiveError, null)), /*#__PURE__*/React.createElement("div", {
    className: styles.codeControls
  }, /*#__PURE__*/React.createElement("button", {
    className: styles.iconButton,
    onClick: function onClick() {
      return setOpen(function (open) {
        return !open;
      });
    }
  }, /*#__PURE__*/React.createElement(EmbedIcon, null))), /*#__PURE__*/React.createElement("div", {
    className: classnames(styles.collapse, _defineProperty({}, styles.open, open))
  }, /*#__PURE__*/React.createElement(LiveEditor, null))));
};
CodeLive.propTypes = {
  language: PropTypes.string,
  scope: PropTypes.array,
  theme: PropTypes.object
};
CodeLive.defaultProps = {
  scope: [],
  theme: themes.vsDark
};
//# sourceMappingURL=CodeLive.js.map